<template>
  <!-- BLOCKLY -->
  <!-- BLOCKLY BASADO EN RESPONDER A EVENTOS -->
  <!-- <BlocklyComponent id="blocklyMain" -->
  <!-- :options="options" :parentWorkspace="workspace" @add="loadBlocklyWorkspace" -->
  <!-- ref="blocklyMain"> -->

  <!-- MENU -->
  <!-- MENU BASADO REQUIERE SER TERMINADO -->
  <!-- <MenuComponent id="menu" :parentWorkspace="workspaceRef"></MenuComponent> -->

  <!-- MENU PRINCIPAL (FOCUS), ESTÁ ES LA BARRA DE TAREAS -->
  <Luna8266FocusMenu
    v-if="'luna8266' == typePrj"
    class="mainMenu"
    :parentWorkspace="workspaceRef"
    :editorSelected="editorSelected"
    :codeFromCodemirror="codeFromCodemirror"
    @savePrj="savePrj"
    @magicCodeEmit="magicCodeReceive"
  ></Luna8266FocusMenu>
  <ChuckFocusMenu
    v-if="'chuck' == typePrj"
    class="mainMenu"
    :workspace="workspaceRef"
    :editorSelected="editorSelected"
    :positionBufferBlockly="positionBufferBlockly"
    :positionBufferCodemirror="positionBufferCodemirror"
    :fileHandle="fileHandleOnlyToRead"
    :codeFromCodemirror="codeFromCodemirror"
    @savePrj="savePrj"
    @magicCodeEmit="magicCodeReceive"
  ></ChuckFocusMenu>

  <!-- SELECT EDITOR -->
  <EditorModeComponent
    @requestToToggleCodemirrorOrBlocklyToShow="selectBlocklyOrCodeMirrorToShow"
    @requesLoadThisBuffer="loadThisBuffer"
    :codemirrorOrBlocklySelected="editorSelected"
  ></EditorModeComponent>

  <div id="editorSpace">
    <!-- BLOCKLY EDITOR -->
    <BlocklyComponent
      v-show="editorSelected == TypeEditor.Blockly"
      id="blocklyMain"
      :options="optionsBlockly"
      :catalejoDataPrj="catalejoDataPrj"
      :positionBufferBlockly="positionBufferBlockly"
      @loadRefWorkspaceBlockly="loadRefWorkspaceBlockly"
      ref="blocklyMain"
    ></BlocklyComponent>
    <!-- CODEMIRROR EDITOR -->
    <CodeMirrorComponent
      v-show="editorSelected == TypeEditor.Codemirror"
      :catalejoDataPrj="catalejoDataPrj"
      :positionBufferCodemirror="positionBufferCodemirror"
      :magicCode="magicCode"
      @loadRefCodeFromCodemirror="loadRefCodeFromCodemirror"
    ></CodeMirrorComponent>
  </div>

  <!-- FLOAT MENU -->
  <!-- Menu de opciones y acceso a otras funciones -->
  <FloatingCircularMenu
    id="menu2"
    :parentWorkspace="workspaceRef"
    @parentSendPreviewCode2Modal="sendPreviewCode2Modal"
    @parentSendConnectModal="sendConnectModal"
  ></FloatingCircularMenu>

  <!-- POPUP -->
  <!-- <SimplePopup id="popup1"></SimplePopup> -->

  <!-- MODAL POPUP -->
  <!-- <div id="modals"></div> -->
  <PreviewCodeModal
    :parentMessage="previewCode2ModalMsg"
    :trigger="triggerPreviewCodeModal"
  ></PreviewCodeModal>

  <ConnectModal
    :parentMessage="connectModalMsg"
    :trigger="triggerConnectModal"
  ></ConnectModal>
  <Chat
    :onSend="handleChatSendEvent"
    :chat="dataChat"
    :bgColorHeader="darkTheme && '#1e1e1e'"
    :bgColorChat="darkTheme && '#2C2D2E'"
    :bgColorInput="darkTheme && '#1e1e1e'"
    :bgColorIcon="darkTheme && '#9B51E0'"
    :bgColorMessageChatbot="darkTheme && '#1e1e1e'"
    :bgColorMessagePerson="darkTheme && '#9B51E0'"
    :bgColorMessageTimestamp="darkTheme && '#1e1e1e'"
    :textColorInput="darkTheme && '#fff'"
    :textColorHeader="darkTheme && '#fff'"
    :textColorMessageChatbot="darkTheme && '#fff'"
    :textColorMessageTimestamp="darkTheme && '#fff'"
  />
</template>

<script lang="ts">
/**
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/**
 * @fileoverview Main Vue component that includes the Blockly component.
 * @author Johnny Cubides <jgcubidesc@gmail.com>
 */

// import { Component, Vue } from 'vue-property-decorator'
import { defineComponent, ref, onMounted, watch } from "vue";
// -- IMPORT COMPONENTS --
import Luna8266FocusMenu from "./editorComponents/focusMenu/Luna8266FocusMenu.vue";
import ChuckFocusMenu from "./editorComponents/focusMenu/ChuckFocusMenu.vue";
import EditorModeComponent from "./editorComponents/EditorModeComponent.vue";
import BlocklyComponent from "./editorComponents/BlocklyComponent.vue";
import CodeMirrorComponent from "./editorComponents/CodeMirrorComponent.vue";
// import MenuComponent from './components/MenuComponent.vue'
// import FloatMenuComponent from './components/FloatMenuComponent.vue'
import FloatingCircularMenu from "./editorComponents/FloatingCircularMenu.vue";
import {
  setBlocklyOptionDefault,
  updateEditorAndBlockly,
  saveCatalejoPrj,
  CatalejoDataPrj,
  TypeEditor,
  getXMLFromBlockly,
  // -- CHAT --
  handleChatSendEvent,
  dataChat,
} from "../host/index";

// -- IMPORT MODALS COMPONENTS --
import PreviewCodeModal from "./editorComponents/modals/PreviewCodeModal.vue";
import ConnectModal from "./editorComponents/modals/ConnectModal.vue";

// -- BLOCKLY LIBS --
import Blockly from "@johnnycubides/blockly-catalejo/";
// -- BLOCKLY TOOLBOX --
//import { toolbox } from "./blockly-config/example/toolbox-example"; // Ejemplo
//import { toolbox } from "./blockly-config/example/toolbox-simple-xml.js";
// -- BLOCKLY LANGUAGE GENERATOR --
//import "./blockly-config/luabot/luabot";

// import './blocks/stocks'
// import './prompt'

// --CHAT AND MONITOR --
import Chat from "./@chat-ui/Chat.vue";

export default defineComponent({
  components: {
    Luna8266FocusMenu,
    ChuckFocusMenu,
    BlocklyComponent,
    CodeMirrorComponent,
    EditorModeComponent,
    // MenuComponent,
    // FloatMenuComponent,
    FloatingCircularMenu,
    // -- START MODALS COMPONENTS START --
    PreviewCodeModal,
    ConnectModal,
    //-- CHAT AND MONITOR
    Chat,
  },
  // tslint:disable-next-line
  props: ["fileHandle"],
  setup (props, context) { // eslint-disable-line
    // -- VARS --
    const typePrj = ref("");
    // codeFromCodemirror cambia por cada evento generado al editar texto allí
    const codeFromCodemirror = ref({});
    // -- PROPS --
    const editorSelected = ref(TypeEditor.Blockly);
    const catalejoDataPrj = ref();
    const workspaceRef = ref(new Blockly.Workspace());
    // -- PROPS BLOCKLY --
    const positionBufferBlockly = ref(0);
    const optionsBlockly = ref({});
    // Codemirror no se expone inmediatamente, por tanto será
    // cargado apenas se carge un archivo, pasará de -1 a 0
    const positionBufferCodemirror = ref(-1);
    // magicCode hace referencia a las solicitudes de agregar código
    // a codemirror que provienen de Blockly
    const magicCode = ref({});
    // -- MODALS VARS MSG --
    const previewCode2ModalMsg = ref("");
    const connectModalMsg = ref("");
    // -- MODALS TRIGGERS --
    const triggerPreviewCodeModal = ref(false);
    const triggerConnectModal = ref(false);
    const fileHandleOnlyToRead = ref();

    // Condición inicial para cargar las opciones de blockly
    optionsBlockly.value = setBlocklyOptionDefault;

    watch(
      () => props.fileHandle,
      async (newFile) => {
        const configEditor = await updateEditorAndBlockly(newFile);
        optionsBlockly.value = configEditor.optionsBlockly;
        catalejoDataPrj.value = new CatalejoDataPrj(
          configEditor.catalejoProjectObj.TYPE_PRJ,
          configEditor.catalejoProjectObj.BLOCKLY,
          configEditor.catalejoProjectObj.CODEMIRROR
        );
        typePrj.value = catalejoDataPrj.value.getTypePrj();
        fileHandleOnlyToRead.value = props.fileHandle;
        // Solo al cargar archivo se permite cargar buffer en codemirror
        positionBufferCodemirror.value = 0;
      }
    );

    // https://developers.google.com/blockly/guides/configure/web/configuration_struct

    // Esta referencia construye el workspace que será usado en
    // los componentes hijos de la aplicación
    // Emit for child
    const loadRefWorkspaceBlockly = (workspaceToRef) => {
      workspaceRef.value = workspaceToRef;
    };

    //Cuando codemirror esté preparado, dará la referencia al código
    const loadRefCodeFromCodemirror = (codeFromCodemirrorEmited) => {
      codeFromCodemirror.value = codeFromCodemirrorEmited;
    };

    // Emit for child MODAL
    const sendPreviewCode2Modal = (message) => {
      previewCode2ModalMsg.value = message;
      triggerPreviewCodeModal.value = !triggerPreviewCodeModal.value; // trigger the modal
    };

    // Emit for child MODAL
    const sendConnectModal = (message) => {
      connectModalMsg.value = message;
      triggerConnectModal.value = !triggerConnectModal.value; // trigger the modal
    };

    const selectBlocklyOrCodeMirrorToShow = async (posBufferToSave) => {
      if (editorSelected.value == TypeEditor.Blockly) {
        const xml = await getXMLFromBlockly(workspaceRef.value);
        await catalejoDataPrj.value.setBlocklyCode(
          posBufferToSave,
          Blockly.Xml.domToText(xml)
        );
        editorSelected.value = TypeEditor.Codemirror;
      } else {
        await catalejoDataPrj.value.setMirrorCode(
          posBufferToSave,
          codeFromCodemirror.value.value
        );
        // TODO: crear la función para guardar buffer de codemirror
        console.log("se requiere la función para guadar buffer en codemirror");
        editorSelected.value = TypeEditor.Blockly;
      }
    };

    const savePrj = async () => {
      if (editorSelected.value == TypeEditor.Blockly) {
        // const xml = await Blockly.Xml.workspaceToDom(workspaceRef.value);
        const xml = await getXMLFromBlockly(workspaceRef.value);
        await catalejoDataPrj.value.setBlocklyCode(
          positionBufferBlockly.value,
          Blockly.Xml.domToText(xml)
        );
      } else if (editorSelected.value == TypeEditor.Codemirror) {
        await catalejoDataPrj.value.setMirrorCode(
          positionBufferCodemirror.value,
          codeFromCodemirror.value.value
        );
        // TODO: crear funcion para guardar buffer de codemirror
        console.log("crear función para guardar buffer de codemirror");
      }
      saveCatalejoPrj(props.fileHandle, catalejoDataPrj.value);
    };

    const magicCodeReceive = (codeConvertedFromBlockly) => {
      magicCode.value = codeConvertedFromBlockly;
    };

    const loadThisBuffer = async (posBufferToSave, posBufferToLoad) => {
      if (editorSelected.value == TypeEditor.Blockly) {
        const xml = await getXMLFromBlockly(workspaceRef.value);
        await catalejoDataPrj.value.setBlocklyCode(
          posBufferToSave,
          Blockly.Xml.domToText(xml)
        );
        positionBufferBlockly.value = posBufferToLoad;
      } else if (editorSelected.value == TypeEditor.Codemirror) {
        await catalejoDataPrj.value.setMirrorCode(
          posBufferToSave,
          codeFromCodemirror.value.value
        );
        positionBufferCodemirror.value = posBufferToLoad;
        // TODO: crear función para guardar buffer
        console.log("loadThisBuffer codemirror");
        // TODO: positionBufferCodemirror.value = posBufferToLoad;
      }
    };

    //-- CHAT AND MONITOR --
    const darkTheme = ref(true);

    return {
      // --VARS --
      TypeEditor, // Editor.[Blockly, Codemirror]
      catalejoDataPrj,
      typePrj,

      // blockly vars start
      codeFromCodemirror,
      workspaceRef, // general ref of blockly workspace
      optionsBlockly, // options blockly
      // blockly vars end
      // --PROPS--
      positionBufferBlockly,
      positionBufferCodemirror,
      editorSelected,
      fileHandleOnlyToRead,
      magicCode,
      // -- METHODS --
      // -- MODALS VARS MSG --
      previewCode2ModalMsg,
      connectModalMsg,
      // -- MODALS TRIGGERS --
      triggerPreviewCodeModal,
      triggerConnectModal,
      // -- METHODS FOR EMITS --
      selectBlocklyOrCodeMirrorToShow,
      loadRefWorkspaceBlockly,
      loadRefCodeFromCodemirror,
      sendPreviewCode2Modal,
      sendConnectModal,
      updateEditorAndBlockly,
      savePrj,
      magicCodeReceive,
      loadThisBuffer,
      //-- CHAT AND MONITOR --
      darkTheme,
      handleChatSendEvent,
      dataChat,
    };
  },
});
</script>

<style>
/*
#code {
  position: absolute;
  right: 0;
  bottom: 0;
  width: 40%;
  height: 50%;
  margin: 0;
  background-color: beige;
}
*/
/*
#blockly1 {
  position: absolute;
  right: 0;
  top: 0;
  width: 50%;
  height: 50%;
}*/

.mainMenu {
  /*position: absolute;*/
  /*top: 0px;*/
  height: 60px; /* 72px */
  width: 100%;
}

#blocklyMain {
  /* top: 60px; /* 60px, 72px */
  /* position: relative; /* relative, absolute */
  /*left: 0;*/
  /*bottom: 0;*/
  /*width: 100%;*/
  /*height: 90%;*/
}


#modals {
}
</style>
